﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TreeExample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void quitMenu_Click(object sender, EventArgs e)
        {
            Close ();
        }

        private void testMenu_Click(object sender, EventArgs e)
        {
            TreeNode root = new TreeNode ();
            root.Text = "root";
            root.BackColor = Color.Blue;

            TreeNode node = new TreeNode();
            node.Text = "subitem";
            node.ToolTipText = "nejaky text";

            root.Nodes.Add (node);

            tree.Nodes.Add (root);
            tree.ShowNodeToolTips = true;

            root.Expand ();
        }

        private void dragAndDropButton_MouseDown(object sender, MouseEventArgs e)
        {
            DragDropEffects effect;
            if (e.Button == MouseButtons.Right)
                effect = DragDropEffects.Move;
            else
                effect = DragDropEffects.Copy;
            // MouseDown
            DoDragDrop ("nejaka data", effect);
        }

        private void textBox_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;
        }

        private void textBox_DragDrop(object sender, DragEventArgs e)
        {
          foreach (string f in e.Data.GetFormats ())
              textBox.AppendText ("format "+ f + "\n");
            textBox.AppendText (e.Data.GetData (DataFormats.Text) + "\n");
        }

        private void tree_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;
        }

        private void tree_DragOver(object sender, DragEventArgs e)
        {
            Point p = new Point (e.X, e.Y);
            Point p2 = tree.PointToClient (p);
            TreeNode node = tree.GetNodeAt(p2);
            tree.SelectedNode = node;
        }

        private void tree_DragDrop(object sender, DragEventArgs e)
        {
           TreeNode target = tree.SelectedNode;
           TreeNode node = new TreeNode ();
           node.Text = "new item";
           if (target == null)
               tree.Nodes.Add (node);
           else
           {
               target.Nodes.Insert (0, node);
               target.Expand ();
           }
        }
    }
}
